open Main3;;
Extractcalls.extractcalls_program intermed;;
Backend.emit_program intermed;;

let a = 
Code.Seq [
  Code.Label (Gen.new_label ());
  Code.Exp (Code.Un (Code.Not, Code.Temp [Gen.new_temp ()]));
  Code.Exp (Code.Bin (Code.Plus, Code.Temp [Gen.new_temp ()], Code.Temp [Gen.new_temp ()]))
];;

let b = 
  { 
  Code.code = [a]; Code.name = Gen.named_label "main";
  Code.args = [];
  Code.result = [];
  Code.statics = [];
  Code.uses = [];
  Code.defs = [];
  Code.usefuncs = [];
  Code.translating = false;
  Code.translated = false; 
};;

let c = { Code.main = b; Code.funcs = [] };;    

Backend.emit_program c;;

let l = Gen.new_label ();;
let l2 = Gen.new_label ();;
let t1 = Gen.new_byte_temp ();;
let t2 = Gen.new_byte_temp ();;
let b = 
[
  Ass.Label ("mylabel:", l);
  Ass.Oper ("  mov ^s, ^d", [t1], [t2], None);
  Ass.Oper ("  nop", [], [], None);
  Ass.Oper ("  mov ^s, ^d", [t2], [t1], None);
  Ass.Oper ("  jmp mylabel", [], [], Some [l]);
(*  Ass.Oper ("  ret", [t1], [], Some [l2]);*)
] ;;

Liveness.flowgraph b;;
Liveness.flow b;;

#load "partition.cmo";;

let p = make 5;;

open Main3;;
open Code;;
intermed.main;;
intermed.funcs;;
Extractcalls.extractcalls_program intermed;;
let asm = Backend.emit_program intermed;;
Codegen.print_program_ass asm;;
(List.hd (List.tl asm)).Ass.code;;

let h = Heap.create (>) (fun x -> x) 5;;
Heap.add h 0;;
Heap.add h 2;;
Heap.add h 3;;
h;;
for i = 0 to 1000 do try Heap.add h (Random.int 10000) with _ -> () done;;
h;;
Hashtbl.iter (fun i j -> print_int i; print_char ' '; print_int j; print_newline ()) h.Heap.hash;;
Heap.head h;;
Heap.testheap h;;
while true do
  print_int (Heap.head h); print_newline ();
done;;
Heap.remove h 2;;
